<template>
  <div id="lc_individual_question_editor_wrapper">
    <el-row>
      <el-col :span="14">
        <h2>{{ $t('ITEM.EXTRACT_CONDITION') }}</h2>
        <el-form label-width="120px" style="margin-top: 30px;">
          <el-form-item :label="$t('QUESTION.TYPE')" id="question_type">
            <el-radio-group v-model="inputTail.searchCondition.questionType">
              <el-radio-button label="0">{{ $t('QUESTION.MULTI_ANS') }}</el-radio-button>
              <el-radio-button label="1">{{ $t('QUESTION.SHORT_ANS') }}</el-radio-button>
              <el-radio-button label="2">{{ $t('QUESTION.ESSAY') }}</el-radio-button>
              <el-radio-button label="6">{{ $t('QUESTION.MULTIMEDIA') }}</el-radio-button>
            </el-radio-group>
          </el-form-item>
          <el-form-item :label="$t('QUESTION.KEYWORD')">
            <el-select
              v-model="currentKeyword"
              :placeholder="$t('QUESTION.KEYWORD')"
              style="width: 232px;">
              <el-option
                v-for="keyword in keywordList"
                :key="keyword.keyword"
                :label="keyword.keyword"
                :value="keyword.keyword">
              </el-option>
            </el-select>
            <el-button type="primary" @click="addKeyword">
              {{ $t('QUESTION.ADD') }}
            </el-button>
          </el-form-item>
          <el-form-item :label="$t('QUESTION.DIFF')">
            <el-select v-model="inputTail.searchCondition.difficultyMin" style="width: 135px;">
              <el-option
                v-for="level in lsEqArr(inputTail.searchCondition.difficultyMax, difficultyList)"
                :key="level"
                :label="level"
                :value="level">
              </el-option>
            </el-select>
            <span style="margin-left: 10px; margin-right: 10px; font-size: 18px;">~</span>
            <el-select v-model="inputTail.searchCondition.difficultyMax" style="width: 135px;">
              <el-option
                v-for="level in gtEqArr(inputTail.searchCondition.difficultyMin, difficultyList)"
                :key="level"
                :label="level"
                :value="level">
              </el-option>
            </el-select>
          </el-form-item>
        </el-form>
      </el-col>
      <el-col :span="10">
        <h2>{{ $t('QUESTION.QUSETION_KEYWORD') }}</h2>
        <el-table :data="inputTail.searchCondition.keywordSelect" max-height="180" :header-cell-style="{padding: '0', height: '40px'}" :cell-style="{padding: '0', height: '40px'}">
          <el-table-column type='index' label='#' width='50' align="center">
          </el-table-column>
          <el-table-column :label="$t('QUESTION.KEYWORD')">
            <template slot-scope="scope">{{ scope.row }}</template>
          </el-table-column>
          <el-table-column label='-' align="center" width='100'>
            <el-button size="small" type="danger" @click="deleteKeyword(scope.row)" slot-scope="scope">
              {{ $t('QUESTION.DELETE') }}
            </el-button>
          </el-table-column>
        </el-table>
        <el-form-item align="right" style="margin-top: 20px;">
          <el-button type="primary" size="medium" @click="onClick('ADD')" :disabled="inputTail.addDisable">{{ $t('QUESTION.ADD') }}</el-button>
          <el-button size="medium" @click="onClick('RESETEXTRACTCONDITION')">{{ $t('ITEM.RESET') }}</el-button>
        </el-form-item>
      </el-col>
    </el-row>
    <el-row>
      <h2>{{ $t('ITEM.EXTRACT_CONDITION_LIST') }}</h2>
      <el-form label-width="20px">
        <el-form-item>
          <el-table
            :data="inputTail.groupDataList.groupInfoList"
            :header-cell-style="headerStyle">
            <el-table-column
              prop="group"
              :label="$t('ITEM.GROUP')"
              width="70"
              align="center">
            </el-table-column>
            <el-table-column
              :label="$t('ITEM.TYPE')"
              width="120"
              align="center">
              <template slot-scope="scope">{{ translate(scope.row.typeString) }}</template>
            </el-table-column>
            <el-table-column
              prop="difficulty"
              :label="$t('QUESTION.DIFF')"
              width="180"
              align="center">
            </el-table-column>
            <el-table-column
              prop="keywords"
              :label="$t('QUESTION.KEYWORD')"
              align="center">
            </el-table-column>
            <el-table-column
              width="100">
              <template slot-scope="scope">
                <el-button
                  size="small"
                  type="danger"
                  @click="extractionConditionDelete(scope.$index, scope.row)">
                  {{ $t('QUESTION.DELETE') }}
                </el-button>
              </template>
            </el-table-column>
          </el-table>
        </el-form-item>
        <el-form-item align="right" style="margin-right: 30px;">
          <el-button type="primary" size="medium" @click="onClick('EXTRACTION')" :disabled="inputTail.extractionDisable">{{ $t('ITEM.EXTRACT') }}</el-button>
          <el-button size="medium" @click="onClick('RESETEXTRACTCONDITIONS')">{{ $t('ITEM.RESET') }}</el-button>
        </el-form-item>
      </el-form>
    </el-row>
    <el-row :visible.sync="searchFinish">
      <el-col :span="12">
        <h2>{{ $t('ITEM.EXTRACT_RESULT') }}</h2>
      </el-col>
      <el-col :span="12" style="padding-top: 20px;">
        <el-button type="primary" style="float: right;" @click="onClick('SCOREBATCHCHANGE')">{{ $t('ITEM.CHANGE_BATCH_SCORE') }}</el-button>
      </el-col>
    </el-row>
    <el-table
      :visible.sync="searchFinish"
      style="margin-bottom: 20px;"
      :data="inputTail.groupDataList.groupQuestionList">
      <el-table-column :label="$t('ITEM.GROUP')" width="70" align="center">
        <template slot-scope="scope">{{ scope.row.group }}</template>
      </el-table-column>
      <el-table-column :label="$t('ITEM.NAME')">
        <template slot-scope="scope">{{ scope.row.name }}</template>
      </el-table-column>
      <el-table-column :label="$t('ITEM.TYPE')" width="120" align="center">
        <template slot-scope="scope">{{ translate(scope.row.typeString) }}</template>
      </el-table-column>
      <el-table-column :label="$t('QUESTION.DIFF')" width="100" align="center">
        <template slot-scope="scope">{{ scope.row.difficulty }}</template>
      </el-table-column>
      <!--el-table-column label="실질 난이도" width="70" align="center">
        <template slot-scope="scope">{{ scope.row.realDifficulty }}</template>
      </el-table-column-->
      <el-table-column :label="$t('QUESTION.SCORE')" width="70" align="center">
        <el-input slot-scope="scope" v-model="scope.row.score">
          {{ scope.row.score }}
        </el-input>
      </el-table-column>
      <el-table-column
        label="-"
        width="100"
        align="center">
        <template slot-scope="scope">
          <el-button size="small" @click="preview(scope.row)">{{ $t('ITEM.PREVIEW') }}</el-button>
        </template>
      </el-table-column>
      <el-table-column
        label="-"
        width="80"
        align="center">
        <template slot-scope="scope">
          <el-button size="small" type="danger" @click="deleteExtractQuestion(scope.$index)">{{ $t('QUESTION.DELETE') }}</el-button>
        </template>
      </el-table-column>
    </el-table>
    <el-dialog
      :visible.sync="extractionExpectVisible"
      width="20%">
      <span slot="title" style="font-size: 1.2em;">
        {{ $t('ITEM.EXTRACT_REDUNDANCY') }}
      </span>
      <h3>
        ※ {{ $t('ITEM.HIGH_REDUNDANCY_MSG_1') }}
      </h3>
      <h3>
        ※ {{ $t('ITEM.HIGH_REDUNDANCY_MSG_2') }}
      </h3>
      <el-table :data="replicationRateData" :key="replicationRateData.length">
        <el-table-column :label="$t('ITEM.GROUP')"  align="center">
          <template slot-scope="scope">
            {{ scope.row.group }}
          </template>
        </el-table-column>
        <el-table-column :label="$t('ITEM.REDUNDANCY')"  align="center">
          <template slot-scope="scope">
            <span v-if="scope.row.replicationRate !== null">
              {{ scope.row.replicationRate.toFixed(2) }}
            </span>
            <span v-else>
              {{ $t('ITEM.CANT_EXTRACT') }}
            </span>
          </template>
        </el-table-column>
      </el-table><br>
      <el-button type="primary" @click="handleClose('extractionExpect')" style="float: right;">{{ $t('ITEM.CONFIRM') }}</el-button><br><br>
    </el-dialog>
    <el-dialog
      :title="$t('ITEM.PREVIEW')"
      :visible.sync="previewVisible"
      center
      width="40%">
      <lecture-live-item
        :data="lectureItem"
        :onClick="onClick"
        :notRealItem="true"
        :answerSubmitted="false"
        type="TEACHER"/>
      <br>
      <br>
      <span slot="footer" class="dialog-footer">
        <el-button @click="handleClose('preview')">{{ $t('ITEM.CLOSE') }}</el-button>
      </span>
    </el-dialog>
    <el-dialog
      :title="$t('ITEM.CHANGE_BATCH_SCORE')"
      :visible.sync="scoreBatchSettingVisible"
      width="20%">
      <el-table :data="groupScoreData" :key="scoreBatchSettingVisible">
        <el-table-column :label="$t('ITEM.GROUP')"  align="center">
          <template slot-scope="scope">
            {{ scope.row.group }}
          </template>
        </el-table-column>
        <el-table-column :label="$t('QUESTION.SCORE')" align="center" >
          <el-input slot-scope="scope" style="width: 50px !important;" v-model="scope.row.score">
            {{ scope.row.score }}
          </el-input>
        </el-table-column>
      </el-table>
      <span slot="footer" class="dialog-footer">
        <el-button @click="scoreBatchSetting()">{{ $t('QUESTION.CHANGE') }}</el-button>
        <el-button @click="handleClose('scoreBatchSetting')">{{ $t('ITEM.CANCEL') }}</el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script>
// TODO : 메모리, 시간 정수형으로 validate!!!
import { mapState } from 'vuex';
import bankService from '../../services/bankService';
import LectureLiveItem from './LectureLiveItem';
import classService from '../../services/classService';
import utils from '../../utils';

export default {
  name: 'LcQuestionEditor',
  components: {
    LectureLiveItem,
  },
  props: ['isNewItem'],
  data() {
    const initialInputTail = {
      searchCondition: {
        keywordSelect: [],
        difficultyMin: 0,
        difficultyMax: 5,
        realDifficultyMin: 0,
        realDifficultyMax: 5,
        questionType: 0,
        // scoreMin: 1,
        // scoreMax: 10,
      },
      groupDataList: {
        groupInfoList: [],
        groupQuestionList: [],
      },
      addDisable: false,
      extractionDisable: true,
      lectureId: null,
    };
    const initialInputBody = {
      individualType: true,
    };
    return {
      resDataTempStore: {},
      reRenderCount: 0, // 문항 풀이 조건 개인별 총난이도 값이 변경 되었으나 render가 최신화 되지 않아 item의 키값으로 추가
      difficultyList: [0, 0.5, 1, 1.5, 2, 2.5, 3, 3.5, 4, 4.5, 5], // 난이도 선택 리스트
      realDifficultyList: [0, 0.5, 1, 1.5, 2, 2.5, 3, 3.5, 4, 4.5, 5], // 실질 난이도 선택 리스트 변경해야 할 수 있음
      // scoreList: [],
      groupScoreData: [],
      replicationRateData: [],
      extractionExpectVisible: false,
      lectureItem: [],
      studentNumber: 0,
      searchFinish: false,
      previewVisible: false,
      scoreBatchSettingVisible: false,
      inputTail: Object.assign({}, initialInputTail),
      inputBody: Object.assign({}, initialInputBody),
      viewModelInputTail: null,
      currentKeyword: null,
    };
  },
  async mounted() {
    const vm = this;
    const res = await classService.getClassUser({ id: vm.lecture.class_id });
    vm.inputTail.lectureId = vm.lecture.lecture_id;
    vm.studentNumber = res.data.length;
    vm.setExtractionDisable();
  },
  computed: {
    ...mapState('keyword', [
      'keywordList',
    ]),
    ...mapState('lc', [
      'lecture',
    ]),
  },
  methods: {
    translate(type) {
      const vm = this;
      let typeTrans = '';
      switch (type) {
        case '객관': {
          typeTrans = vm.$t('QUESTION.MULTI_ANS');
          break;
        }
        case '단답': {
          typeTrans = vm.$t('QUESTION.SHORT_ANS');
          break;
        }
        case '서술': {
          typeTrans = vm.$t('QUESTION.ESSAY');
          break;
        }
        case '멀티미디어': {
          typeTrans = vm.$t('QUESTION.MULTIMEDIA');
          break;
        }
      }
      return typeTrans;
    },
    scoreBatchSetting() {
      const vm = this;
      vm.inputTail.groupDataList.groupQuestionList.forEach((question) => {
        question.score = vm.groupScoreData[question.group - 1].score; // eslint-disable-line
      });
      // 이거 해결 vm.inputTail.groupDataList.questions.forEach(question => {})
      vm.handleClose('scoreBatchSetting');
    },
    addKeyword() {
      const vm = this;
      if (vm.currentKeyword === null) {
        vm.$notify({
          title: vm.$t('ITEM.KEYWORD_ADD_ERROR'),
          type: 'warning',
          message: vm.$t('ITEM.KEYWORD_ADD_ERROR_MSG_1'),
          duration: 3000,
        });
        return;
      }
      if (!vm.inputTail.searchCondition.keywordSelect
      .some(keyword => keyword === vm.currentKeyword)) {
        vm.inputTail.searchCondition.keywordSelect.push(vm.currentKeyword);
      } else {
        vm.$notify({
          title: vm.$t('ITEM.KEYWORD_ADD_ERROR'),
          type: 'warning',
          message:vm.$t('ITEM.KEYWORD_ADD_ERROR_MSG_2'),
          duration: 3000,
        });
      }
      vm.currentKeyword = null;
    },
    reset() {
      const vm = this;
      vm.inputBody = Object.assign({}, vm.initialInputBody);
      vm.inputTail = Object.assign({}, vm.initialInputTail);
    },
    handleClose(target) {
      const vm = this; // eslint-disable-line
      eval(`vm.${target}Visible = false;`); // eslint-disable-line
    },
    min(a, b) { // 최솟값 리턴
      if (isNaN(a) || isNaN(b)) {
        return null;
      }
      return (a >= b ? b : a);
    },
    extractionConditionDelete(index) {
      const vm = this;
      const groupIdx = vm.inputTail.groupDataList.groupInfoList[index].group;
      vm.inputTail.groupDataList.groupInfoList.splice(index, 1);
      vm.inputTail.groupDataList.groupQuestionList =
      vm.inputTail.groupDataList.groupQuestionList.filter(question => question.group !== groupIdx);
      vm.setExtractionDisable();
    },
    // viewModelInputTail로 초기화 용도(수정시)
    copyInputTail(newValue, type) {
      const vm = this;
      if (type === 0) {
        vm.inputTail = {
          searchCondition: {
            questionType: newValue.searchCondition.questionType,
            keywordSelect: newValue.searchCondition.keywordSelect,
            difficultyMin: newValue.searchCondition.difficultyMin,
            difficultyMax: newValue.searchCondition.difficultyMax,
          },
          groupDataList: {
            groupInfoList: [{
              group: newValue.groupDataList.groupInfoList[0].group,
              type: newValue.groupDataList.groupInfoList[0].type,
              typeString: newValue.groupDataList.groupInfoList[0].typeString,
              difficulty: newValue.groupDataList.groupInfoList[0].difficulty,
              keywords: newValue.groupDataList.groupInfoList[0].keywords,
            }],
            groupQuestionList: newValue.groupDataList.groupQuestionList,
          },
          extractionDisable: newValue.extractionDisable,
          lectureId: newValue.lectureId,
        };
      } else if (type === 1) {
        vm.inputTail.searchCondition = {
          questionType: newValue.searchCondition.questionType,
          keywordSelect: newValue.searchCondition.keywordSelect,
          difficultyMin: newValue.searchCondition.difficultyMin,
          difficultyMax: newValue.searchCondition.difficultyMax,
        };
      } else if (type === 2) {
        vm.inputTail.groupDataList = {
          groupInfoList: [{
            group: newValue.groupDataList.groupInfoList[0].group,
            type: newValue.groupDataList.groupInfoList[0].type,
            typeString: newValue.groupDataList.groupInfoList[0].typeString,
            difficulty: newValue.groupDataList.groupInfoList[0].difficulty,
            keywords: newValue.groupDataList.groupInfoList[0].keywords,
          }],
          groupQuestionList: newValue.groupDataList.groupQuestionList,
          extractionDisable: newValue.extractionDisable,
        };
      } else if (type === 3) {
        vm.inputTail.searchCondition = {
          questionType: 0,
          keywordSelect: [],
          difficultyMin: 0,
          difficultyMax: 5,
        };
      } else if (type === 4) {
        vm.inputTail.groupDataList.groupInfoList = [];
        vm.inputTail.groupDataList.groupQuestionList = [];
      }
    },
    setExtractionDisable() {
      const vm = this;
      if (vm.isNewItem === false) {
        vm.inputTail.extractionDisable = (vm.inputTail.groupDataList.groupInfoList.length !== 1);
      } else {
        vm.inputTail.extractionDisable = (vm.inputTail.groupDataList.groupInfoList.length === 0);
      }
    },
    headerStyle() {
      return 'padding: 0px;';
    },
    deleteExtractQuestion(index) {
      const vm = this;
      vm.$confirm(vm.$t('ITEM.DELETE_EXTRACTION_MSG'), 'Warning', {
        confirmButtonText: vm.$t('ITEM.YES'),
        cancelButtonText: vm.$t('ITEM.NO'),
        type: 'warning',
      }).then(() => {
        vm.$notify({
          title:vm.$t('ITEM.DELETE_EXTRACTION'),
          type: 'success',
          message: vm.$t('ITEM.DELETE_EXTRACTION_SUCCESS_MSG'),
          duration: 1000,
        });
        const group = vm.inputTail.groupDataList.groupQuestionList[index].group;
        vm.inputTail.groupDataList.groupQuestionList.splice(index, 1);
        if (vm.inputTail.groupDataList.groupQuestionList
        .filter(question => question.group === group).length === 0) {
          vm.inputTail.groupDataList.groupInfoList = vm.inputTail.groupDataList.groupInfoList
          .filter(info => info.group !== group);
        }
      }).catch(() => {
        vm.$notify({
          title: vm.$t('ITEM.DELETE_EXTRACTION'),
          type: 'info',
          message: vm.$t('ITEM.DELETE_EXTRACTION_CANCEL_MSG'),
          duration: 1000,
        });
      });
    },
    lsEqArr(gt, array) {
      const result = [];
      array.forEach((item) => {
        if (item <= gt) {
          result.push(item);
        }
      });
      return result;
    },
    gtEqArr(ls, array) {
      const result = [];
      array.forEach((item) => {
        if (item >= ls) {
          result.push(item);
        }
      });
      return result;
    },
    deleteKeyword(row) {
      const vm = this;
      vm.inputTail.searchCondition.keywordSelect = vm.inputTail.searchCondition.keywordSelect
      .filter((item) => {
        if (item === row) {
          return false;
        }
        return true;
      });
    },
    preview(lectureItem) {
      const vm = this;
      if (vm.isNewItem) {
        vm.lectureItem = lectureItem.data;
        vm.lectureItem.bank_questions[0].question_keywords = [];
        vm.lectureItem.bank_questions[0].bank_question_keywords = undefined;
        vm.lectureItem.bank_questions[0].question_material = [];
        vm.lectureItem.bank_questions[0].files = [];
        vm.lectureItem.bank_questions[0].problem_testcases = [];
        vm.lectureItem.bank_questions[0].student_answer_logs = [];
        vm.lectureItem.bank_questions[0].sql_lite_file = [];
        vm.lectureItem.questions = vm.lectureItem.bank_questions;
        vm.lectureItem.notRealItem = true;
      } else {
        vm.lectureItem = lectureItem.data.lecture_item;
        vm.lectureItem.questions = [lectureItem.data];
      }
      vm.previewVisible = true;
    },
    async onClick(action) {
      const vm = this;
      switch (action) {
        case 'SUBMIT': {
          break;
        }
        case 'SCOREBATCHCHANGE': {
          vm.groupScoreData = [];
          let forEachCount = 0;
          vm.inputTail.groupDataList.groupInfoList.forEach(() => {
            vm.groupScoreData[forEachCount] = {
              group: forEachCount + 1,
              score: 10,
            };
            forEachCount += 1;
          });
          vm.scoreBatchSettingVisible = true;
          break;
        }
        case 'ADD': {
          if (vm.inputTail.searchCondition.keywordSelect.length === 0) {
            vm.$notify({
              title: vm.$t('ITEM.EXTRACTION_EXCEPTION_1'),
              type: 'warning',
              message: vm.$t('ITEM.EXTRACTION_EXCEPTION_1_MSG'),
              duration: 1000,
            });
            break;
          }
          if (vm.isNewItem === false && vm.inputTail.groupDataList.groupInfoList.length > 0) {
            vm.$notify({
              title: vm.$t('ITEM.EXTRACTION_EXCEPTION_2'),
              type: 'warning',
              message: vm.$t('ITEM.EXTRACTION_EXCEPTION_2_MSG'),
              duration: 1000,
            });
            break;
          }
          let newGroup = 1;
          let fin = false;
          vm.inputTail.groupDataList.groupInfoList.forEach((groupInfo) => {
            if (fin === false && newGroup === groupInfo.group) {
              newGroup += 1;
            } else {
              fin = true;
            }
          });
          vm.inputTail.groupDataList.groupInfoList.push({
            group: newGroup,
            type: Number(vm.inputTail.searchCondition.questionType),
            typeString: utils.convertQuestionType(Number(vm.inputTail.searchCondition.questionType)),
            difficulty: `${vm.inputTail.searchCondition.difficultyMin}~${vm.inputTail.searchCondition.difficultyMax}`,
            keywords: vm.inputTail.searchCondition.keywordSelect.join(','),
          });
          vm.inputTail.searchCondition.keywordSelect = [];
          vm.setExtractionDisable();
          break;
        }
        case 'EXTRACTION': {
          let forEachCount = 0;
          const bulgaGroup = [];
          vm.inputTail.groupDataList.groupQuestionList = [];
          vm.replicationRateData = [];
          vm.inputTail.groupDataList.groupInfoList.forEach(async (item) => {
            const res = await bankService.getBankLectureSearchQuestions({
              lectureId: vm.lecture.lecture_id,
              questionType: item.type,
              keywords: item.keywords,
              diff: item.difficulty.split('~').join(','),
              // realDiff: item.realDifficulty.split('~').join(','),
              // scores: item.scoreMin + ',' + item.scoreMax,
              // multipleChoiceQuestionNumber: item.multipleChoiceQuestionNumber,
              // shortAnswerQuestionNumber: item.shortAnswerQuestionNumber,
              // narrativeQuestionNumber: item.narrativeQuestionNumber,
              // swQuestionNumber: item.swQuestionNumber,
              // sqlQuestionNumber: item.sqlQuestionNumber,
              // multiMediaQuestionNumber: item.multiMediaQuestionNumber,
            });
            forEachCount += 1;
            vm.replicationRateData[forEachCount - 1] = {
              group: item.group,
              questionNumber: 0,
              studentNumber: vm.studentNumber,
              replicationRate: null,
            };
            const customSort = (a, b) => {
              if (a.group === b.group) {
                return 0;
              }
              return a.group > b.group ? 1 : -1;
            };
            res.data.questionArray.forEach((question) => {
              vm.replicationRateData[forEachCount - 1].questionNumber += 1;
              vm.inputTail.groupDataList.groupQuestionList.push({
                group: item.group,
                name: question.name,
                type: question.bank_questions[0].type,
                typeString: utils.convertQuestionType(question.bank_questions[0].type),
                bank_lecture_item_id: question.lecture_item_id,
                difficulty: Number(question.bank_questions[0].difficulty),
                // realDifficulty: question.bank_questions[0].realDifficulty,
                score: Number(question.bank_questions[0].score),
                data: question,
              });
            });
            vm.inputTail.groupDataList.groupQuestionList.sort(customSort);
            if (vm.replicationRateData[forEachCount - 1].questionNumber === 0) {
              vm.replicationRateData[forEachCount - 1].replicationRate = null;
            } else {
              vm.replicationRateData[forEachCount - 1].replicationRate = Number(
              vm.replicationRateData[forEachCount - 1].studentNumber
              / vm.replicationRateData[forEachCount - 1].questionNumber);
            }
            if (res.data.questionArray.length === 0) {
              bulgaGroup.push(item.group);
            }
            if (forEachCount === vm.inputTail.groupDataList.groupInfoList.length) {
              if (res.data.bankLectureExist === 0) {
                vm.$notify({
                  title: vm.$t('ITEM.IMP_EXTRACTION_GROUP'),
                  type: 'warning',
                  message: vm.$t('ITEM.IMP_EXTRACTION_GROUP_MSG_1'),
                  duration: 5000,
                });
              } else if (bulgaGroup.length > 0) {
                vm.$notify({
                  title: vm.$t('ITEM.IMP_EXTRACTION_GROUP'),
                  type: 'warning',
                  message: vm.$t('ITEM.IMP_EXTRACTION_GROUP_MSG_2', { msg: bulgaGroup.join(',')}),
                  duration: 5000,
                });
              } else {
                vm.extractionExpectVisible = true;
                vm.searchFinish = true;
              }
            }
          });
          break;
        }
        case 'RESETEXTRACTCONDITION': { // 수 제한 초기화
          if (vm.isNewItem) {
            vm.copyInputTail(vm.viewModelInputTail, 3);
          } else {
            vm.copyInputTail(vm.viewModelInputTail, 1);
          }
          break;
        }
        case 'RESETEXTRACTCONDITIONS': { // 수 제한 초기화
          if (vm.isNewItem) {
            vm.copyInputTail(vm.viewModelInputTail, 4);
          } else {
            vm.copyInputTail(vm.viewModelInputTail, 2);
          }
          vm.setExtractionDisable();
          break;
        }
        default:
          break;
      }
    },
  },
};
</script>